#include "mainwindow.h"
#include "ui_mainwindow.h"

#include  <QtDebug>
#include <QMetaObject>
#include <QMetaMethod>
#include <QAxObject>

#include "SterlingAPI.h"

QString APPVERSION = "0007";

// https://doc.qt.io/archives/qt-4.8/activeqt-dumpdoc.html
// dumpcpp  -getfile {C418ADDA-61CC-4854-B69E-87F8BF6D7A0E}
// dumpcpp  -o SterlingAPI (-getfile {C418ADDA-61CC-4854-B69E-87F8BF6D7A0E})
MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
    , ui(new Ui::MainWindow)
{

    qDebug() << "Test Case v" << APPVERSION;
    m_sSymbol = "AAPL";
    m_sExchange = "";


//    m_pApp = new SterlingLib::STIApp(this);
//    bool v_bIsApiEnabled = m_pApp->IsApiEnabled();
//    QAxObject object("C418ADDA-61CC-4854-B69E-87F8BF6D7A0E", this);
    m_APP = new SterlingLib::STIApp(this);
    bool v_bFlag = m_APP->IsApiEnabled();
    qDebug() << "API is " << (v_bFlag?"ENABLED":"DISABLED");
    m_pPosition = new SterlingLib::STIPosition(this);
    m_pPosition->setObjectName("RealTimePositions__");

    m_pQuote_1 = new SterlingLib::STIQuote(this);
    m_pQuote_1->setObjectName("Quote_1__"); // Quote_1 in handlers
    {
        const QMetaObject* v_pQuoteMetaObject = m_pQuote_1->metaObject();
        {
        qDebug() << "STIQuote methods: ========================================";
            QStringList methods;
            for(int i = v_pQuoteMetaObject->methodOffset(); i < v_pQuoteMetaObject->methodCount(); ++i) {
                QString v_sSignature = QString::fromLatin1(v_pQuoteMetaObject->method(i).methodSignature());
                methods << v_sSignature;
                qDebug() << v_sSignature << v_pQuoteMetaObject->method(i).methodType() ;
            }
        }
    }


    QString v_sPosiyionObjectName = m_pPosition->objectName();

    const QMetaObject* v_pMainWindowMetaObject = this->metaObject();
    {
    qDebug() << "MainWindow methods: ========================================";
        QStringList methods;
        for(int i = v_pMainWindowMetaObject->methodOffset(); i < v_pMainWindowMetaObject->methodCount(); ++i) {
            QString v_sSignature = QString::fromLatin1(v_pMainWindowMetaObject->method(i).methodSignature());
            methods << v_sSignature;
            qDebug() << v_sSignature << v_pMainWindowMetaObject->method(i).methodType() ;
        }
    }

    const QMetaObject* v_pPositionsMetaObject = m_pPosition->metaObject();
    {
    qDebug() << "Position methods: ========================================";
        QStringList methods;
        for(int i = v_pPositionsMetaObject->methodOffset(); i < v_pPositionsMetaObject->methodCount(); ++i) {
            QString v_sSignature = QString::fromLatin1(v_pPositionsMetaObject->method(i).methodSignature());
            methods << v_sSignature;
            qDebug() << v_sSignature << v_pMainWindowMetaObject->method(i).methodType() ;
        }
    }


//    v_pPositionsMetaObject->connectSlotsByName(this);
    m_pPosition->setParent(this);
//    QMetaObject::connectSlotsByName(this);
    QStringList v_ArrayDests;
    QString v_sServerTime =  m_APP->GetServerTime();
    qDebug() << "MainWindow::MainWindow ServerTime = " << v_sServerTime;
    long v_dDestSize =  m_APP->GetDestinationList(v_ArrayDests);

    if ( v_bFlag) {
        v_bFlag = m_APP->IsApiEnabled();
        v_sServerTime =  m_APP->GetServerTime();
    }
    v_sServerTime = m_APP->dynamicCall("GetServerTime()").toString(); // qt docs for this way to call functions

    v_dDestSize =  m_APP->GetDestinationList(v_ArrayDests);
    m_APP->SetModeXML(true);


    ui->setupUi(this);

//    m_pQuote_1->RegisterQuote(m_sSymbol, m_sExchange);
//    bool v_bRegistered = m_pQuote_1->IsQuoteRegistered(m_sSymbol, m_sExchange);
//    if (!v_bRegistered) {
//        qDebug() << "MainWindow::MainWindow symbol " << m_sSymbol << " is not registered.";
//    }

//    m_pPosition->RegisterForPositions();
    QObject::connect(m_pPosition, SIGNAL(OnSTIPositionUpdateXML(QString&))
                     , this, SLOT(on_RealTimePositions_OnSTIPositionUpdateXML(QString&))
//                     , Qt::ConnectionType::UniqueConnection
                     );
    return;

}
// ==========================================================================
MainWindow::~MainWindow()
{
    delete ui;
}
// ==========================================================================
void MainWindow::onXML(QString& ) {
    return;
}
// ==========================================================================
void MainWindow::on_RealTimePositions_OnSTIPositionUpdateXML(QString& a_sXML) {
    qDebug() << "MainWindow::"<<Q_FUNC_INFO<< " " <<a_sXML;
    return;
}
// ==========================================================================
void MainWindow::on_RealTimePositions_exception(int a_dInt,QString a_s1,QString a_s2, QString a_s3){
    qDebug() << "MainWindow::on_RealTimePositions_exception " << a_dInt
             << " " << a_s1
             << " " << a_s2
             << " " << a_s3 ;
}
// =======================================================
// quptes
//    OnSTIGreeksUpdate(structSTIGreeksUpdate*);
// =======================================================
void MainWindow::on_Quote_1_OnSTIGreeksUpdateXML(QString& a_sXML) {
    qDebug() << "MainWindow::"<<Q_FUNC_INFO<< " "  << a_sXML;

}
// =======================================================
//    OnSTIL2Reply(QList<structSTIL2Update>*);
// =======================================================
    void MainWindow::on_Quote_1_OnSTIL2ReplyXML(QString&a_sXML) {
        qDebug() << "MainWindow::"<<Q_FUNC_INFO<< " "  << a_sXML;

    }
// =======================================================
//    OnSTIL2Update(structSTIL2Update*);
// =======================================================
    void MainWindow::on_Quote_1_OnSTIL2UpdateXML(QString&a_sXML) {
        qDebug() << "MainWindow::"<<Q_FUNC_INFO<< " "  << a_sXML;

    }
// =======================================================
//    OnSTINewsUpdate(structSTINewsUpdate*);
// =======================================================
    void MainWindow::on_Quote_1_OnSTINewsUpdateXML(QString&a_sXML) {
        qDebug() << "MainWindow::"<<Q_FUNC_INFO<< " "  << a_sXML;

    }
// =======================================================
//    OnSTIQuoteRqst(structSTIQuoteRqst*);
    void MainWindow::on_Quote_1_OnSTIQuoteRqstXML(QString&a_sXML) {
        qDebug() << "MainWindow::"<<Q_FUNC_INFO<< " "  << a_sXML;

    }
// =======================================================
//    OnSTIQuoteSnap(structSTIQuoteSnap*);
// =======================================================
    void MainWindow::on_Quote_1_OnSTIQuoteSnapXML(QString&a_sXML) {
        qDebug() << "MainWindow::"<<Q_FUNC_INFO<< " "  << a_sXML;

    }
// =======================================================
//    OnSTIQuoteUpdate(structSTIQuoteUpdate*);
// =======================================================
    void MainWindow::on_Quote_1_OnSTIQuoteUpdateXML(QString&a_sXML) {
        qDebug() << "MainWindow::"<<Q_FUNC_INFO<< " "  << a_sXML;

    }
// =======================================================
//    OnSTIScannerUpdate(structSTIScannerUpdate*);
// =======================================================
    void MainWindow::on_Quote_1_OnSTIScannerUpdateXML(QString&a_sXML) {
        qDebug() << "MainWindow::"<<Q_FUNC_INFO<< " "  << a_sXML;

    }
// =======================================================
    void MainWindow::on_Quote_1_OnSTIShutdown() {
        qDebug() << "MainWindow::"<<Q_FUNC_INFO<< " " ;

    }
// =======================================================
void MainWindow::on_Quote_1_exception(int a_dInt,QString a_s1,QString a_s2, QString a_s3){
          qDebug() << "MainWindow::"<<Q_FUNC_INFO<< " "  << a_dInt
                   << " " << a_s1
                   << " " << a_s2
                   << " " << a_s3 ;
      }
// =======================================================
    void MainWindow::on_Quote_1_propertyChanged(QString a_sXML) {
        qDebug() << "MainWindow::"<<Q_FUNC_INFO<< " "  << a_sXML;

    }
// =======================================================
void MainWindow::on_Quote_1_signal(QString a_sXML,int a_dInt,void*) {
    qDebug() << "MainWindow::"<<Q_FUNC_INFO<< " "  << a_sXML << " " << a_dInt;

}
// =======================================================



void MainWindow::on_pushButton_clicked() {
        qDebug() << "MainWindow::"<<Q_FUNC_INFO<< " "  ;
        bool v_bFlag = m_APP->IsApiEnabled();
        qDebug() << "API is " << (v_bFlag?"ENABLED":"DISABLED");
        m_pPosition->RegisterForPositions();
        m_pQuote_1->RegisterQuote(m_sSymbol, m_sExchange);
        bool v_bRegistered = m_pQuote_1->IsQuoteRegistered(m_sSymbol, m_sExchange);
        if (!v_bRegistered) {
            qDebug() << " symbol " << m_sSymbol << " is not registered.";
        }


}
