#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QAxBase>
#include <QString>

#include "SterlingAPI.h"

QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE



class MainWindow : public QMainWindow
{
    Q_OBJECT
    SterlingLib::STIApp * m_APP;
    SterlingLib::STIPosition * m_pPosition; // RealTimePositions
    SterlingLib::STIQuote * m_pQuote_1; // Quote_1 on_Quote_1_
    QString m_sSymbol;
    QString m_sExchange;


//    SterlingLib::STIApp * m_pApp;


public:
    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();
public slots:
    void onXML(QString& a_sXML);
    void on_RealTimePositions_OnSTIPositionUpdateXML(QString &a_sXML);
    void on_RealTimePositions_exception(int,QString,QString,QString);

// quptes
//    OnSTIGreeksUpdate(structSTIGreeksUpdate*);
    void on_Quote_1_OnSTIGreeksUpdateXML(QString&);
//    OnSTIL2Reply(QList<structSTIL2Update>*);
    void on_Quote_1_OnSTIL2ReplyXML(QString&);
//    OnSTIL2Update(structSTIL2Update*);
    void on_Quote_1_OnSTIL2UpdateXML(QString&);
//    OnSTINewsUpdate(structSTINewsUpdate*);
    void on_Quote_1_OnSTINewsUpdateXML(QString&);
//    OnSTIQuoteRqst(structSTIQuoteRqst*);
    void on_Quote_1_OnSTIQuoteRqstXML(QString&);
//    OnSTIQuoteSnap(structSTIQuoteSnap*);
    void on_Quote_1_OnSTIQuoteSnapXML(QString&);
//    OnSTIQuoteUpdate(structSTIQuoteUpdate*);
    void on_Quote_1_OnSTIQuoteUpdateXML(QString&);
//    OnSTIScannerUpdate(structSTIScannerUpdate*);
    void on_Quote_1_OnSTIScannerUpdateXML(QString&);
    void on_Quote_1_OnSTIShutdown();
    void on_Quote_1_exception(int,QString,QString,QString);
    void on_Quote_1_propertyChanged(QString);
    void on_Quote_1_signal(QString,int,void*);

private slots:
    void on_pushButton_clicked();

private:
    Ui::MainWindow *ui;
};
#endif // MAINWINDOW_H
